"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _getListsError = _interopRequireDefault(require("../../utils/errors/getListsError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var LIST_VIEW_THRESHOLD = 5000;
$().SPServices({
  operation: "GetListCollection",
  async: false,
  completefunc: function completefunc(xData, status) {
    if (status === "success") {
      var $list = $(xData.responseXML).SPFilterNode("List").eq(0);

      if ($list.length > 0) {
        LIST_VIEW_THRESHOLD = parseInt($list.attr("MaxItemsPerThrottledOperation"));
      } else {
        console.warn("No lists found on current site. Unable to determinte the list view threshold");
      }
    } else {
      console.error((0, _getListsError["default"])(xData));
    }
  }
});
var _default = LIST_VIEW_THRESHOLD;
exports["default"] = _default;