"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * @name getVersionCollection
 * @description Returns information about items in the list based on the specified query.
 * @required listName
 * @param {Object} payload The configuration payload object
 * @param {String} payload.listName The list display name or GUID
 * @param {String} [payload.webURL=window.$().SPServices.defaults.webURL || ""] The web site url
 * @param {String} [payload.field="Title"] The field static name to retrieve version history.
 * @param {Boolean} [payload.parse=false] If true, the response will be passed
 */
var getVersionCollection = function getVersionCollection(_ref) {
  var ID = _ref.ID,
      listName = _ref.listName,
      _ref$webURL = _ref.webURL,
      webURL = _ref$webURL === void 0 ? $().SPServices.defaults.webURL : _ref$webURL,
      _ref$async = _ref.async,
      async = _ref$async === void 0 ? true : _ref$async,
      _ref$field = _ref.field,
      field = _ref$field === void 0 ? "Title" : _ref$field,
      _ref$parse = _ref.parse,
      parse = _ref$parse === void 0 ? false : _ref$parse;
  return new Promise(function (resolve, reject) {
    $().SPServices({
      operation: "GetVersionCollection",
      webURL: webURL,
      async: async,
      strlistID: listName,
      strlistItemID: ID,
      strFieldName: field,
      completefunc: function completefunc(xData, status) {
        var res = xData.responseXML;

        if (status === "success") {
          if (parse) {
            var items = _toConsumableArray(res.querySelectorAll("Version")).map(function (xml) {
              return _defineProperty({
                Modified: xml.getAttribute("Modified"),
                Editor: xml.getAttribute("Editor")
              }, field, xml.getAttribute(field));
            });

            resolve(items);
          } else {
            resolve(res);
          }
        } else {
          var message = _toConsumableArray(res.querySelectorAll("*")).find(function (_ref3) {
            var nodeName = _ref3.nodeName;
            return nodeName === "errorstring";
          });

          if (message) {
            message = message.innerHTML;
          }

          reject({
            message: message,
            code: xData.status,
            status: xData.statusText
          });
        }
      }
    });
  });
};

var _default = getVersionCollection;
exports["default"] = _default;