"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var _window = window,
    $ = _window.$;
var parser = new DOMParser();
/**
 * @name siteDataGetList
 * @description Returns metadata from the specified SharePoint list.
 * @param {object} options
 * @param {string} options.listName A string that contains either the name of the list or the GUID of the list enclosed in curly braces ({}).
 * @param {string} [options.webURL=""] The relative or absolute webURL.
 * @param {boolean} [options.async=true] If true, the web request will be asynchronous.
 * @returns {Promise}
 */

var siteDataGetList = function siteDataGetList() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$webURL = _ref.webURL,
      webURL = _ref$webURL === void 0 ? "" : _ref$webURL,
      listName = _ref.listName,
      _ref$async = _ref.async,
      async = _ref$async === void 0 ? true : _ref$async;

  return new Promise(function (resolve, reject) {
    $().SPServices({
      operation: "SiteDataGetList",
      webURL: webURL,
      strListName: listName,
      async: async,
      completefunc: function completefunc(_ref2, status) {
        var responseXML = _ref2.responseXML;

        // If success
        if (status === "success") {
          // Get list fromx ml
          var list = _toConsumableArray(responseXML.querySelector("sListMetadata").children).reduce(function (object, node) {
            object[node.nodeName] = node.textContent;
            return object;
          }, {}); // Get permissions (if found)


          var permissionsXML = parser.parseFromString(list.Permissions, "text/xml"); // Get list permission objects

          list.Permissions = _toConsumableArray(permissionsXML.querySelectorAll("Permission")).map(function (node) {
            return _toConsumableArray(node.attributes).reduce(function (object, _ref3) {
              var nodeName = _ref3.nodeName,
                  nodeValue = _ref3.nodeValue;
              object[nodeName] = nodeValue;
              return object;
            }, {});
          }); // Resolve list

          resolve(list);
        } else {
          reject("Error getting site data list");
        }
      }
    });
  });
};

var _default = siteDataGetList;
exports["default"] = _default;