"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var getViewCollection = function getViewCollection() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      listName = _ref.listName,
      _ref$webURL = _ref.webURL,
      webURL = _ref$webURL === void 0 ? "" : _ref$webURL,
      _ref$async = _ref.async,
      async = _ref$async === void 0 ? true : _ref$async;

  return new Promise(function (resolve, reject) {
    $().SPServices({
      operation: "GetViewCollection",
      webURL: webURL,
      listName: listName,
      async: async,
      completefunc: function completefunc(xData, status) {
        if (status === "success") {
          try {
            // Array to store views
            var views = [];
            Array.from(xData.responseXML.getElementsByTagName("View")).forEach(function (xml) {
              var view = {};
              var attributes = xml.attributes;

              for (var i = 0; i < attributes.length; i++) {
                var attribute = attributes[i];
                view[attribute.name] = attribute.value;
              }

              views.push(view);
            });
            resolve(views);
          } catch (err) {
            reject(err);
          }
        } else {
          reject(xData.responseXML);
        }
      }
    });
  });
};

var _default = getViewCollection;
exports["default"] = _default;