// columnNames = [
//   // Custom Columns
//   "FirstName",
//   "LastName",
//   "Email",
//   "Gender",
//   "Interests",

//   // View Columns
//   "Title",
//   "ID",
//   "Modified",
//   "Created",
//   "Author",
//   "Editor",
//   "FileDirRef"
// ];
// System Columns
const listColumns = [
  "ContentTypeId",
  "ContentType",
  "owshiddenversion",
  "WorkflowVersion",
  "_UIVersion",
  "_UIVersionString",
  "Attachments",
  "_ModerationStatus",
  "LinkTitleNoMenu",
  "LinkTitle",
  "LinkTitle2",
  "SelectTitle",
  "Order",
  "GUID",
  "FileRef",
  "Last_x0020_Modified",
  "Created_x0020_Date",
  "FSObjType",
  "SortBehavior",
  "PermMask",
  "FileLeafRef",
  "UniqueId",
  "ProgId",
  "ScopeId",
  "_EditMenuTableStart",
  "_EditMenuTableStart2",
  "_EditMenuTableEnd",
  "LinkFilenameNoMenu",
  "LinkFilename",
  "LinkFilename2",
  "ServerUrl",
  "EncodedAbsUrl",
  "BaseName",
  "_Level",
  "_IsCurrentVersion",
  "ItemChildCount",
  "FolderChildCount",
  "MetaInfo_vti_versionhistory"
];

class Response {
  constructor({
    xml,
    CAMLViewFields = "",
    allowNullValues = true,
    keyDelimiter = "",
    viewColumns = null
  }) {
    if (!allowNullValues && CAMLViewFields) {
      // Get View Fields
      const viewFields = $.parseXML(CAMLViewFields);
      // Add all view fields as empty properties
      $(viewFields)
        .SPFilterNode("FieldRef")
        .toArray()
        .forEach(field => {
          field = field.getAttribute("Name");
          this[field] = "";
        });
    }

    // Get all attributes as properties and values
    this._createObjectFromAttributes(xml, keyDelimiter, viewColumns);
  }

  _createObjectFromAttributes(xml, keyDelimiter, viewColumns) {
    const attributes = xml.attributes;
    for (let i = 0; i < attributes.length; i++) {
      const attribute = attributes[i];
      let key = attribute.name;
      if (keyDelimiter) {
        key = key.split(keyDelimiter)[1];
      }

      if (viewColumns === true && listColumns.indexOf(key) !== -1) {
        continue;
      }

      this[key] = attribute.value;
    }
  }
}

export default Response;
