import Response from "../Response";

class Item extends Response {
  constructor({
    xml,
    CAMLViewFields,
    allowNullValues,
    viewColumns = null
  } = {}) {
    super({
      xml,
      CAMLViewFields,
      allowNullValues,
      keyDelimiter: "ows_",
      viewColumns
    });

    if (typeof this.FileDirRef !== "undefined") {
      const path = this.FileDirRef.split("/");
      this.ListName = path[path.length - 1];
      this.ListUrl = `/${this.FileDirRef.split("#")[1]}`;
      this.DispFormUrl = `${this.ListUrl}/DispForm.aspx?ID=${this.ID}`;
      this.EditFormUrl = `${this.ListUrl}/EditForm.aspx?ID=${this.ID}`;
      this.NewFormUrl = `${this.ListUrl}/NewForm.aspx`;
    }

    if (typeof this.Editor !== "undefined")
      this.ModifiedBy = this.Editor.split("#")[1];

    if (typeof this.Author !== "undefined")
      this.CreatedBy = this.Author.split("#")[1];
  }
}

export default Item;
