import getListsError from "../../utils/errors/getListsError";

let LIST_VIEW_THRESHOLD = 5000;

$().SPServices({
  operation: "GetListCollection",
  async: false,
  completefunc: function (xData, status) {
    if (status === "success") {
      let $list = $(xData.responseXML).SPFilterNode("List").eq(0);
      if ($list.length > 0) {
        LIST_VIEW_THRESHOLD = parseInt(
          $list.attr("MaxItemsPerThrottledOperation")
        );
      } else {
        console.warn(
          "No lists found on current site. Unable to determinte the list view threshold"
        );
      }
    } else {
      console.error(getListsError(xData));
    }
  },
});

export default LIST_VIEW_THRESHOLD;
