const getViewCollection = ({ listName, webURL = "", async = true } = {}) => {
  return new Promise((resolve, reject) => {
    $().SPServices({
      operation: "GetViewCollection",
      webURL,
      listName,
      async,
      completefunc: function (xData, status) {
        if (status === "success") {
          try {
            // Array to store views
            const views = [];
            Array.from(xData.responseXML.getElementsByTagName("View")).forEach(
              (xml) => {
                let view = {};
                const attributes = xml.attributes;
                for (let i = 0; i < attributes.length; i++) {
                  const attribute = attributes[i];
                  view[attribute.name] = attribute.value;
                }
                views.push(view);
              }
            );
            resolve(views);
          } catch (err) {
            reject(err);
          }
        } else {
          reject(xData.responseXML);
        }
      },
    });
  });
};
export default getViewCollection;
