const getErrorFromXml = xData => {
  const code =
    (
      [...xData.responseXML.getElementsByTagName("errorcode")][0] ||
      [...xData.responseXML.getElementsByTagName("ErrorCode")][0] ||
      {}
    ).textContent || "";

  const message =
    (
      [...xData.responseXML.getElementsByTagName("ErrorText")][0] ||
      [...xData.responseXML.getElementsByTagName("errorstring")][0] ||
      {}
    ).textContent || "";

  const error = {
    message,
    code,
    status: xData.status
  };

  return error;
};

const getErrorFromXData = xData => {
  return {
    message: xData.statusText,
    code: null,
    status: xData.status
  };
};

const error = xData => {
  let error = {};
  if (xData.responseXML) {
    error = getErrorFromXml(xData);
  } else {
    error = getErrorFromXData(xData);
  }
  return error;
};

export default error;

export { getErrorFromXml, getErrorFromXData, error };
