import ERROR_CODES from "../../constants/errorCodes";

/**
 * @name getError
 * @param {Object} xml The response xml object/document
 * @returns {Object} Returns an error object
 */
const getError = xml => {
  if (!xml) return {};
  const code = xml.querySelector("ErrorCode").textContent || "";
  const error = ERROR_CODES[code] || { code };
  return error;
};

export default getError;
