/**
 * escapeHtml - Escapes HTML characters
 *
 * @param  {string} str Requires a string
 * @return {string}     Returns a string with escaped HTML
 */
const escapeHtml = (str) => {
  // If not a string, return argument
  if (typeof str !== "string") return str;
  if (str) {
    return str
      .replace(/&/g, "&amp;")
      .replace(/</g, "&lt;")
      .replace(/>/g, "&gt;")
      .replace(/"/g, "&quot;")
      .replace(/'/g, "&#039;");
  }
  return "";
};

export default escapeHtml;
