/**
 * @name getNodeAttributes
 * @description Converts a node's attributes into an object
 * @param {Object} node
 * @returns {Object} Returns an objects with the nodes attributes as keys and props
 */
const getNodeAttributes = (node) =>
  !node
    ? // If undefined, return object literal
      {}
    : // Else, Iterate through attributes and convert to object
      [...node.attributes].reduce((object, node) => {
        object[node.name] = node.value || "";
        return object;
      }, {});

export default getNodeAttributes;
