/**
 * @name handleListItemsParserError
 * @description Handles parsing rows from responseText that contains a parser error
 * @param {String} responseText The response Text
 */
const handleListItemsParserError = ({ responseText = "" } = {}) => {
  // Array literal to store rows
  let rows = [];

  // Split response text by line
  responseText.split("\n").forEach((line) => {
    // Trim the line
    let string = line.trim();

    // If the string is a row
    if (string.startsWith("<z:row")) {
      // Get the rows from the parsed xml and push to array
      rows.push(...parser.parseFromString(string, "text/xml").children);
    }
  });

  // Return rows
  return rows;
};
