/**
 * @name getCurrentUser
 * @description Gets the current logged in user.
 * @returns {Promise} Returns a Promise XML result.
 */
const getCurrentUser = options => {
  return new Promise((resolve, reject) => {
    let user = {};
    try {
      user = $().SPServices.SPGetCurrentUser({
        webURL: "",
        fieldNames: [
          "Account",
          "Name",
          "Title",
          "EMail",
          "Notes",
          "Picture",
          "Department",
          "JobTitle",
          "SipAddress",
          "FirstName",
          "LastName",
          "WorkPhone",
          "Office",
          "UserName",
          "SPResponsibility"
        ], // Added in v0.7.2 to allow multiple columns
        debug: false
      });
      resolve(user);
    } catch (error) {
      reject(error);
    }
  });
};

export default getCurrentUser;
