"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.error = exports.getErrorFromXData = exports.getErrorFromXml = exports["default"] = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var getErrorFromXml = function getErrorFromXml(xData) {
  var code = (_toConsumableArray(xData.responseXML.getElementsByTagName("errorcode"))[0] || _toConsumableArray(xData.responseXML.getElementsByTagName("ErrorCode"))[0] || {}).textContent || "";
  var message = (_toConsumableArray(xData.responseXML.getElementsByTagName("ErrorText"))[0] || _toConsumableArray(xData.responseXML.getElementsByTagName("errorstring"))[0] || {}).textContent || "";
  var error = {
    message: message,
    code: code,
    status: xData.status
  };
  return error;
};

exports.getErrorFromXml = getErrorFromXml;

var getErrorFromXData = function getErrorFromXData(xData) {
  return {
    message: xData.statusText,
    code: null,
    status: xData.status
  };
};

exports.getErrorFromXData = getErrorFromXData;

var error = function error(xData) {
  var error = {};

  if (xData.responseXML) {
    error = getErrorFromXml(xData);
  } else {
    error = getErrorFromXData(xData);
  }

  return error;
};

exports.error = error;
var _default = error;
exports["default"] = _default;