"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _errorCodes = _interopRequireDefault(require("../../constants/errorCodes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * @name getError
 * @param {Object} xml The response xml object/document
 * @returns {Object} Returns an error object
 */
var getError = function getError(xml) {
  if (!xml) return {};
  var code = xml.querySelector("ErrorCode").textContent || "";
  var error = _errorCodes["default"][code] || {
    code: code
  };
  return error;
};

var _default = getError;
exports["default"] = _default;