"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/**
 * @name convertStringToXml
 * @description Converts a string to XML. This is used when an API response has invalid characters
 * @param {String} string The XML string to be parsed
 * @param {Object} [parser] A DOMParser object
 */
var convertStringToXml = function convertStringToXml(string) {
  var parser = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  // If string is not defined
  if (!string || typeof string !== "string") {
    console.error("Unable to convert string to xml as the string was not defined.");
    return "";
  } // Create parser (if not already created)


  var domParser = parser ? parser : new DOMParser(); // Replace illegal characters

  var text = string.replace(/&/g, "&amp;"); // Parse xml

  var xml = domParser.parseFromString(text, "text/xml");
  return xml;
};

var _default = convertStringToXml;
exports["default"] = _default;