"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/**
 * escapeHtml - Escapes HTML characters
 *
 * @param  {string} str Requires a string
 * @return {string}     Returns a string with escaped HTML
 */
var escapeHtml = function escapeHtml(str) {
  // If not a string, return argument
  if (typeof str !== "string") return str;

  if (str) {
    return str.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#039;");
  }

  return "";
};

var _default = escapeHtml;
exports["default"] = _default;