"use strict";

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * @name handleListItemsParserError
 * @description Handles parsing rows from responseText that contains a parser error
 * @param {String} responseText The response Text
 */
var handleListItemsParserError = function handleListItemsParserError() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$responseText = _ref.responseText,
      responseText = _ref$responseText === void 0 ? "" : _ref$responseText;

  // Array literal to store rows
  var rows = []; // Split response text by line

  responseText.split("\n").forEach(function (line) {
    // Trim the line
    var string = line.trim(); // If the string is a row

    if (string.startsWith("<z:row")) {
      // Get the rows from the parsed xml and push to array
      rows.push.apply(rows, _toConsumableArray(parser.parseFromString(string, "text/xml").children));
    }
  }); // Return rows

  return rows;
};