"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _getListItems = _interopRequireDefault(require("../../core/lists/getListItems"));

var _addListItem = _interopRequireDefault(require("./addListItem"));

var _getList = _interopRequireDefault(require("../../core/lists/getList"));

var _escapeHtml = _interopRequireDefault(require("../general/escapeHtml"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var copyListItems = function copyListItems(_ref) {
  var _ref$source = _ref.source,
      source = _ref$source === void 0 ? null : _ref$source,
      _ref$destination = _ref.destination,
      destination = _ref$destination === void 0 ? null : _ref$destination;

  if (!source || !destination) {
    var error = "Unable to copy list items as a source and/or destination list was not defined";
    window.alert(error);
    return error;
  }

  var listName = source;
  new Promise(function (resolve, reject) {
    (0, _getList["default"])({
      listName: listName,
      parse: true
    }).then(function (list) {
      var fields = list.fields.filter(function (field) {
        if (field.FromBaseType !== "TRUE" && field.Type !== "WorkflowStatus" || field.StaticName === "Title") {
          return {};
        }
      }).map(function (field) {
        var StaticName = field.StaticName,
            DisplayName = field.DisplayName;
        return {
          StaticName: StaticName,
          DisplayName: DisplayName
        };
      });
      resolve({
        fields: fields,
        listName: listName,
        destination: destination
      });
    });
  }).then(function (res) {
    var fields = res.fields,
        listName = res.listName,
        destination = res.destination;
    return new Promise(function (resolve, reject) {
      (0, _getListItems["default"])({
        listName: listName,
        parseItems: true
      }).then(function (listItems) {
        var items = [];
        listItems.forEach(function (listItem) {
          var item = {};
          fields.forEach(function (field) {
            var key = field.StaticName;
            var value = (0, _escapeHtml["default"])(listItem[field.StaticName]);
            if (value) item[key] = value;
          });
          items.push(item);
        });
        resolve({
          items: items,
          destination: destination
        });
      });
    });
  }).then(function (res) {
    var items = res.items,
        destination = res.destination;
    var listName = destination;
    items.forEach(function (item) {
      var valuepairs = [];

      for (var key in item) {
        if (item.hasOwnProperty(key)) {
          valuepairs.push([key, item[key]]);
        }
      }

      (0, _addListItem["default"])({
        listName: listName,
        valuepairs: valuepairs,
        async: false
      }).then(function (item) {});
    });
    alert("Finished");
  });
};

var _default = copyListItems;
exports["default"] = _default;