"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var getListOptions = function getListOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (typeof options.webURL === "undefined") options.webURL = window.$().SPServices.defaults.webURL || "";
  if (typeof options.async === "undefined") options.async = true;
  if (typeof options.templateID === "undefined") options.templateID = "100";
  if (typeof options.description === "undefined") options.description = "";
  if (typeof options.timeout === "undefined") options.timeout = 0;
  if (typeof options.debug === "undefined") options.debug = false;
  if (typeof options.rawXml === "undefined") options.rawXml = false;
  if (typeof options.valuepairs === "undefined") options.valuepairs = []; // parseItems is deprecated but still required for backend use.
  // If options.parse is defined, update parse

  if (typeof options.parseItems === "undefined") options.parseItems = false;
  if (typeof options.parse === "undefined") options.parse = false;

  if (typeof options.parseItems === "undefined" && typeof options.parse !== "undefined") {
    options.parseItems = options.parse;
  }

  if (typeof options.maxBatchSize === "undefined") options.maxBatchSieze = null; // ============================ Start getList options ============================

  if (typeof options.readOnlyColumns === "undefined") options.readOnlyColumns = null;
  if (typeof options.hiddenColumns === "undefined") options.hiddenColumns = null;
  if (typeof options.customColumns === "undefined") options.customColumns = null;
  if (typeof options.viewColumns === "undefined") options.viewColumns = null;
  if (typeof options.columnAttributes === "undefined") options.columnAttributes = []; // ============================ Finish getList options ============================
  // If ListName (single list web requests only) is an Array, convert to string

  if (options.listName && !Array.isArray(options.listName)) {
    options.listName = options.listName.toString();
  } // If ListNames (multiple list web requests) is not an Array, convert to array.


  if (options.listNames && !Array.isArray(options.listNames)) {
    options.listNames = [options.listNames];
  } // If the listNames prop was used instead of listNames and listName is null. Add the listName from the first listNames instance.


  if (typeof options.listName === "undefined" && typeof options.listNames !== "undefined" && options.listNames.length > 0) {
    options.listName = options.listNames[0];
  }

  if (typeof options.CAMLViewFields === "undefined") options.CAMLViewFields = "<ViewFields Properties='True' />";
  if (typeof options.CAMLQuery === "undefined") options.CAMLQuery = "<Query><Where><IsNotNull><FieldRef Name=\"ID\" /></IsNotNull></Where></Query>";
  if (typeof options.CAMLQueryOptions === "undefined") options.CAMLQueryOptions = "<QueryOptions></QueryOptions>";
  if (typeof options.CAMLRowLimit === "undefined") options.CAMLRowLimit = 0;
  return options;
};

var _default = getListOptions;
exports["default"] = _default;