"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var getViewOptions = function getViewOptions(options) {
  if (typeof options.webURL === "undefined") options.webURL = $().SPServices.defaults.webURL || "";
  if (typeof options.async === "undefined") options.async = true; // View Name

  if (typeof options.viewName === "undefined") options.viewName = "CustomView_".concat(Date.now()); // Type

  if (typeof options.type === "undefined") options.type = "HTML"; // Make Default View

  if (typeof options.makeViewDefault === "undefined") options.makeViewDefault = false; // Query

  if (typeof options.query === "undefined") options.query = "<Query></Query>";
  if (typeof options.viewFields === "undefined") // View Fields
    options.viewFields = "<ViewFields><FieldRef Name='Title' /></ViewFields>"; // Row Limit

  if (typeof options.rowLimit === "undefined") {
    options.rowLimit = "<RowLimit paged='True'>100</RowLimit>";
  } else {
    // If Row Limit is a number and not an XML string.
    if (!isNaN(options.rowLimit)) options.rowLimit = "<RowLimit paged='True'>".concat(options.rowLimit, "</RowLimit>");
  }

  return options;
};

var _default = getViewOptions;
exports["default"] = _default;