"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _getPageHtmlFromUrl = _interopRequireDefault(require("../general/getPageHtmlFromUrl"));

var _getList = _interopRequireDefault(require("../../core/lists/getList"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * @name getWebPermissions
 * @description Get the permissions for a web
 * @param {Object} payload
 * @param {String} [payload.webURL=window.$().SPServices.defaults.webURL] The absolute or relative webURL
 * @returns {Promise<Array>} Resolves an array of objects
 */
var getWebPermissions = function getWebPermissions() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$webURL = _ref.webURL,
      webURL = _ref$webURL === void 0 ? window.$().SPServices.defaults.webURL : _ref$webURL;

  return new Promise(function (resolve, reject) {
    // Create the page URL
    var url = "".concat(webURL, "/_layouts/user.aspx"); // Get the Page HTML

    (0, _getPageHtmlFromUrl["default"])({
      url: url
    }).then(function (page) {
      try {
        // Get all permissions
        var permissions = _toConsumableArray(page.querySelectorAll(".ms-listviewtable tbody tr:not(:first-child)")).map(function (tr) {
          var data = _toConsumableArray(tr.querySelectorAll("td:not(:first-child)")).map(function (el) {
            return (el.textContent || "").trim();
          });

          return {
            name: data[0],
            isUser: data[1] === "User",
            permissions: data[2].split(", ").sort()
          };
        }); // Resolve array of objects


        resolve(permissions);
      } catch (error) {
        reject(error);
      }
    })["catch"](function (error) {
      reject(error);
    });
  });
};

var _default = getWebPermissions;
exports["default"] = _default;