"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/**
 * @name getCurrentUser
 * @description Gets the current logged in user.
 * @returns {Promise} Returns a Promise XML result.
 */
var getCurrentUser = function getCurrentUser(options) {
  return new Promise(function (resolve, reject) {
    var user = {};

    try {
      user = $().SPServices.SPGetCurrentUser({
        webURL: "",
        fieldNames: ["Account", "Name", "Title", "EMail", "Notes", "Picture", "Department", "JobTitle", "SipAddress", "FirstName", "LastName", "WorkPhone", "Office", "UserName", "SPResponsibility"],
        // Added in v0.7.2 to allow multiple columns
        debug: false
      });
      resolve(user);
    } catch (error) {
      reject(error);
    }
  });
};

var _default = getCurrentUser;
exports["default"] = _default;